unit frmnewelement;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, fpJson;



type
  { TNewElementForm }

  TNewElementForm = class(TForm)
    BOK: TButton;
    BCancel: TButton;
    EValue: TEdit;
    EElementName: TEdit;
    LEValue: TLabel;
    LENodeText: TLabel;
    Panel1: TPanel;
    PButtons: TPanel;
    RGDataType: TRadioGroup;
    procedure BOKClick(Sender: TObject);
    procedure RGDataTypeClick(Sender: TObject);
  private
    FHP: Boolean;
    function GetDataType: TJSonType;
    function GetElementName: String;
    function GetElementValue: String;
    function GetNeedName: Boolean;
    procedure SetNeedName(const AValue: Boolean);
    { private declarations }
  public
    { public declarations }
    Property DataType : TJSonType Read GetDataType;
    Property ElementName : String Read GetElementName;
    Property ElementValue : String Read GetElementValue;
    Property NeedName : Boolean Read GetNeedName Write SetNeedName;
  end;

var
  NewElementForm: TNewElementForm;

implementation

resourcestring
  SErrNameNeeded = 'Need a name for a tag.';

{ TNewElementForm }

procedure TNewElementForm.BOKClick(Sender: TObject);
begin
  If (GetDataType in [jtNumber,jtBoolean]) then
    If (ElementValue='') then
      raise Exception.Create(SErrNameNeeded);
end;

procedure TNewElementForm.RGDataTypeClick(Sender: TObject);
begin
  With EValue do
    begin
    Enabled:=RGDataType.ItemIndex<3;
    If not Enabled then
      Text:='';
    end;
end;

function TNewElementForm.GetDataType: TJSonType;
begin
  Result:=TJSONType(RGDataType.ItemIndex+1);
end;

function TNewElementForm.GetElementName: String;
begin
  Result:=EElementName.Text;
end;

function TNewElementForm.GetElementValue: String;
begin
  Result:=EValue.Text;
end;

function TNewElementForm.GetNeedName: Boolean;
begin
  Result:=EElementName.Enabled;
end;

procedure TNewElementForm.SetNeedName(const AValue: Boolean);
begin
  EElementName.Enabled:=AValue;
end;

initialization
  {$I frmnewelement.lrs}

end.

