unit frmNewNode;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, dom;



type
  TNodeLocation = (nlFirstChild,nlLastChild,nlBeforeCurrent,nlReplaceCurrent);
  { TNewNodeForm }

  TNewNodeForm = class(TForm)
    BOK: TButton;
    BCancel: TButton;
    ENodeText: TEdit;
    LENodeText: TLabel;
    Panel1: TPanel;
    PButtons: TPanel;
    RGLocation: TRadioGroup;
    RGNodeType: TRadioGroup;
    procedure BOKClick(Sender: TObject);
    procedure RGLocationClick(Sender: TObject);
    function GetNodeLocation: TNodeLocation;
    function GetNodeText: String;
    function GetNodeType: Integer;
    procedure SetHP(const AValue: Boolean);
  private
    FHP: Boolean;
    { private declarations }
  public
    { public declarations }
    Property NodeType : Integer Read GetNodeType;
    Property NodeText : String Read GetNodeText;
    Property NodeLocation : TNodeLocation Read GetNodeLocation;
    Property HaveParent : Boolean Read FHP Write SetHP;
  end;

var
  NewNodeForm: TNewNodeForm;

implementation

resourcestring
  SErrNameNeeded = 'Need a name for a tag.';

{ TNewNodeForm }

procedure TNewNodeForm.RGLocationClick(Sender: TObject);
begin
  Case RGLocation.ItemIndex of
    0 : LENodeText.Caption:='&Name';
    1 : LENodeText.Caption:='&Text';
  end;
end;

procedure TNewNodeForm.BOKClick(Sender: TObject);
begin
  If (GetNodeType=ELEMENT_NODE) then
    If (NodeText='') then
      raise Exception.Create(SErrNameNeeded);
end;

function TNewNodeForm.GetNodeLocation: TNodeLocation;
begin
  Result:=TNodeLocation(RGLocation.ItemIndex);
end;

function TNewNodeForm.GetNodeText: String;
begin
  Result:=ENodeText.Text;
end;

function TNewNodeForm.GetNodeType: Integer;
begin
  Case RGLocation.ItemIndex of
    0 : Result:=ELEMENT_NODE;
    1 : Result:=TEXT_NODE;
  end;
end;

procedure TNewNodeForm.SetHP(const AValue: Boolean);
begin
  if FHP=AValue then exit;
  If FHP then
    begin
    RGLocation.Items.Delete(3);
    RGLocation.Items.Delete(2);
    end;
end;

initialization
  {$I frmnewnode.lrs}

end.

